/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Aufgabe 2 aus Kapitel Bildverarbeitung
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
private boolean fertig = false;
protected boolean tasteGedrueckt = false;
protected PImage  bildOriginal, bildFertig;// bildAusgewaehlt; 
private int[][] tempMatrix; 
protected int h,w, wahl;
protected int g = 1; //Stärke des Filters (= Anzahl er Anwendungen)
protected float faktor =1;//Geeignet, um bei scharfzeichnen oder Relief das Bild heller(faktor <2) oder dunkler zu machen
private float a = 1;
private int w1, h1;//Anzahl der Pixel in Breite und Höhe am Bildschirm

Gauss blur;
Sobel edge;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup(){  
    size(800,600);
    background(0);
  
    textSize(14);
    text("Filtersammlung", 40, 40); 
    text("<1> Bild mit dem Gaußfilter weichzeichnen.", 40, 100); 
    text("<2> Kanten aus dem Bild extrahieren.", 40, 160); 
    text("Die Filter können mehrfach angewendet werden. ", 40, 220);   
    text("Das bearbeitete Bild wird automatisch im Programmordner gespeichert und kann dort erneut geladen werden.", 40, 280); 
    text("Dieses Fenster mit der Maus anklicken und die Taste <1> oder <2> drücken...", 40, 360); 
    text("...und die gewünschte jpg-Bilddatei wählen.",40,420);
   
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void draw() {
  if(tasteGedrueckt == true && key == '1'){
 
      bildFertig = bildWeichzeichnen(bildOriginal);   
  }
  if(tasteGedrueckt == true && key == '2'){
 
      bildFertig = bildKanten(bildOriginal);   
  }
  
  if(fertig){ 
    //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
    //Verbleibende Seite proportional vergrößert/verkleinert
    image(bildFertig,0,0,w/a,h/a);
    bildFertig.save("bildBearbeitet.jpg");
    fertig = false;
  }
}
///////////////////////////////////////////////////////////////////////
void keyPressed() {
  
 
   if (key == '1') {//Bild weichzeichnen 
     colorMode(RGB,255,255,255);
     g = 2; 
     bildWaehlen();
   }
   if (key == '2') {//Kanten finden 
     colorMode(RGB,255,255,255);
     g = 1; 
     bildWaehlen();
   }
   
   
}

/////////////////////////////////////////////////////////////////////// 
//Die folgenden beiden Methoden bewirken, dass ein Lade-Dialog erscheint  
////////////////////////////////////////////////////////////////////////      
 void bildWaehlen(){
      selectInput("", "bildAusgewaehlt");
        while (bildOriginal == null) {
        delay(200);
      }
      loop();
      w =bildOriginal.width; h = bildOriginal.height  ;
      //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
      //Verbleibende Seite proportional vergrößert/verkleinert
      if(w>=h){  
        a =(float)w/800; 
        w1 = int( w/a); 
        h1 = int((float)h/a); 
      }else{
        a = (float)h/800; 
        h1 =int( h/a);  
        w1 = int((float)w/a);
      }   
      surface.setSize(w1,h1);
      tasteGedrueckt = true;
 }
///////////////////////////////////////////////////////////////////////////// 
  void bildAusgewaehlt(File auswahl)
    {
      bildOriginal = loadImage(auswahl.getAbsolutePath());
    }
/////////////////////////////////////////////////////////////////////
//Funktion, die ein Pixelbild in eine Matrix verwandelt
public int[][] matrixVonBild(PImage bildEingabe){
  
  PImage bild = bildEingabe;
  int h = bild.height;
  int w = bild.width;
  int[][] bearbeitetMatrix = new int[w][h];
  for(int i = 0; i < w; i++){
    for(int j = 0; j < h; j++){
     bearbeitetMatrix[i][j] = bild.pixels[i + j*w];
    } 
 }
 return bearbeitetMatrix;
}
////////////////////////////////////////////////////////////////////////
//Matrix in Bild verwandeln
public PImage bildVonMatrix(int[][] matrix){
  
   int[][] bearbeitetMatrix = matrix;
   int zeilen =bearbeitetMatrix[0].length ;
   int spalten = bearbeitetMatrix.length;
    PImage bild = createImage(spalten,zeilen,RGB);
   for(int i = 0; i < spalten; i++){
     for(int j = 0; j < zeilen; j++){
       bild.pixels[i + j*spalten] = bearbeitetMatrix[i][j];
     } 
  }
 return bild;
}
/////////////////////////////////////////////////////////////////////
//Weichzeichnen mit 7x7 Gaußmatrix
public PImage bildWeichzeichnen(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Gauß-Weichzeichnen 
   int[][] bearbeitetMatrix = new int[w][h];  
    tempMatrix = new int[w][h]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    blur   = new Gauss(bearbeitetMatrix);
    bearbeitetMatrix = blur.gaussAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true; 
  
    return bildBearbeitet;   
 } 
 
/////////////////////////////////////////////////////////////////////
//Kanten finden mit zwei Matrizen
public PImage bildKanten(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Kanten finden
   int[][] bearbeitetMatrix = new int[w][h];  
    tempMatrix = new int[w][h]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    edge   = new Sobel(bearbeitetMatrix);
    bearbeitetMatrix = edge.sobelAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true; 
  
    return bildBearbeitet;   
 }